/* memoryDebug.h - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */
#ifndef _memorydebug_h
#define _memorydebug_h

#define malloc(size) xmalloc (size, __FILE__, __LINE__)
#define calloc(elements, size) xcalloc (elements, size, __FILE__, __LINE__)
#define strdup(data) xstrdup (data, __FILE__, __LINE__)
#define free(mem_ref) xfree(mem_ref)

#ifndef DND_FUNCTIONS
/* MODULAR ACCESSIBLE */ void *xmalloc(unsigned int size, const char *file, unsigned int line);
/* MODULAR ACCESSIBLE */ void *xcalloc(unsigned int elements, unsigned int size, const char *file, unsigned int line);
/* MODULAR ACCESSIBLE */ char *xstrdup(const char *data, const char *file, unsigned int line);
/* MODULAR ACCESSIBLE */ void xfree(void *mem_ref);

void initMemoryDebug();
#endif
#endif
