/* cmd_neonserv_devoiceall.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* argv[0]    (optional) nick mask
*/

CMD_BIND(neonserv_cmd_devoiceall) {
    int issuer_access, victim_access, done_users = 0;
    char *nickmask = NULL;
    struct ChanUser *chanuser;
    struct ModeBuffer *modeBuf;
    if(argc > 0)
        nickmask = argv[0];
    modeBuf = initModeBuffer(client, chan);
    issuer_access = getChannelAccess(user, chan);
    for(chanuser = getChannelUsers(chan, NULL); chanuser; chanuser = getChannelUsers(chan, chanuser)) {
        if(nickmask && match(nickmask, chanuser->user->nick)) continue;
        victim_access = getChannelAccess(chanuser->user, chan);
        if(victim_access >= issuer_access) continue;
        if(!(chanuser->flags & CHANUSERFLAG_VOICED)) continue;
        modeBufferDevoice(modeBuf, chanuser->user->nick);
        done_users++;
    }
    freeModeBuffer(modeBuf);
    reply(textclient, user, "NS_DEVOICEALL_DONE", done_users, chan->name);
    if(done_users)
        logEvent(event);
}
